(*$Q+ *)
MODULE AMULTI; (* V0.8 Copyright 1987 fred brooks LogicTek *)
(* IMPORT         GEMError; *)
  FROM TextIO         IMPORT     WriteString,WriteCard,WriteLn,ReadString,
                                 SetDefaultIO;
  FROM Conversions    IMPORT     ConvertToString;
  FROM M2Conversions  IMPORT     ConvertReal,ConvertToInteger;
  FROM BitStuff       IMPORT     WAnd,WShr;
  FROM GEMDOS         IMPORT     PrnOut,ExecMode,Exec,Open,Close,Alloc,
                                 Shrink,Free,Create,GetPath,GetDrv,Read;
  FROM GEMX           IMPORT     BasePageType;
  FROM XBIOS          IMPORT     SuperExec;
  FROM BIOS           IMPORT     Device,BConStat,BConIn,BConOut;
  FROM Streams        IMPORT     Stream,StreamKinds,OpenStream,
                                 CloseStream,Read8Bit,EOS;
  FROM SYSTEM         IMPORT     ADR,BYTE,ADDRESS,NULL,CODE,PROCESS,
                                 REGISTER,SETREG;

  FROM   ATOMIC   IMPORT  Initsked,MultiEnd,MultiBegin,EndProcesses,
                          InitProcesses,StartProcess,currentprocess,
                          TermProcess,SIGNAL,SwapProcess,request,MAGIC,
                          CheckFlag,SetFlag,ResetFlag,CheckResetFlag,
                          command,SleepProcess,WakeupProcess,slicebegin,
                          contextswitch,ChangeProcessPriority,CRON;

  FROM   SCANNER  IMPORT  scinit,nxparm,ltext,etext,bkparm,state;

  FROM   Strings  IMPORT  Compare,Pos,Length,Concat,Copy,Delete,Insert,
                          Assign,CompareResults,String;


VAR
       t,key,result,pri,inputpid                : INTEGER;
       proc                                     : PROC;
       memsize                                  : ADDRESS;
       sizemem,sizewsp,temphz200,cronslice,
       crontick                                 : LONGCARD;
       membot [432H]                            : LONGCARD;
       memtop [436H]                            : LONGCARD;
       hz200  [4baH]                            : LONGCARD;
       OpenWindows, i2,k,delay                  : CARDINAL;
       cmdstring,temp,name,tail,envstr,pname    : String;
       process1,process2,process3,
       sig1,sig2,inuse,printing,printabort,
       background,ok                            : BOOLEAN;
       topusermem,botusermem,usermemleft        : LONGCARD;
       codeadr                                  : POINTER TO BasePageType;


CONST
  TITLE = " AMULTI V0.8   Copyright LogicTek 1987 Fred Brooks ";
  SYSLOG = "SYS.LOG";
  CONSOLE = "CON:";

PROCEDURE       dummy;
BEGIN
END             dummy;

PROCEDURE       readline(VAR str: ARRAY OF CHAR; dev: Device);
VAR             inline                          :       String;
                i,j,k                           :       CARDINAL;
                inchar                          :       CHAR;
                longchar                        :       LONGCARD;
                SHOW                            :       BOOLEAN;
BEGIN
        i:=0;
        j:=HIGH(str)-1;
        LOOP
                IF i=j THEN     (* end of string set to zero, exit *)
                   str[i]:=CHAR(0);
                   EXIT
                END;

                REPEAT  (* wait until a char is waiting *)
                        IF OpenWindows#0 THEN EXIT END;
                UNTIL BConStat(dev);

                longchar:=BConIn(dev);
                inchar:=CHAR(longchar);
                SHOW:=TRUE;
                IF inchar=CHAR(0dH) THEN (* CR *)
                   str[i]:=CHAR(0);
                   EXIT;
                END;
                IF inchar=CHAR(08H) THEN (* BS *)
                   IF i>0 THEN 
                      DEC(i);
                   ELSE
                      SHOW:=FALSE;
                   END;
                END;
                IF SHOW THEN BConOut(dev,inchar) END;
                IF inchar#CHAR(8) THEN
                   str[i]:=inchar;
                   INC(i);
                END;
        END;
END     readline;

PROCEDURE       input;
BEGIN
        inputpid:=currentprocess^.pid;
        MultiBegin;
        LOOP
                IF OpenWindows=0 THEN
                   MultiEnd;
                   WriteString(" Input Request: ");
                   MultiBegin;
                   readline(command,CON);
                   IF OpenWindows=0 THEN
                      WriteLn;
                      request.pid:=currentprocess^.pid; (* V0.7 *)
                      request.magic:=MAGIC;
                      SetFlag(request.req);
                   END;
                   MultiBegin;
                   SwapProcess;
                ELSE
                   SwapProcess;
                   SleepProcess(inputpid);  (* sleep input *) 
                END;
        END;
END     input;

PROCEDURE       SP;
VAR             result                            : INTEGER;
                ch                                : BYTE;
                S                                 : Stream;
                filename                          : String;
                endpos,currentpos                 : LONGCARD;
                C,char                            : POINTER TO CHAR;
BEGIN
        filename:=name;
        OpenStream(S,filename,READ,currentprocess^.return);
        IF currentprocess^.return<0 THEN
           currentprocess^.errno:=2;
        ELSE
           currentpos:=0;
           endpos:=S.endPos;
           Alloc(endpos,C);
           char:=C;
           IF char#NIL THEN
              Read(S.handle,endpos,char);
              CloseStream(S,currentprocess^.return);
              MultiBegin;
              REPEAT
                 SwapProcess;
              UNTIL NOT CheckFlag(printing);
              SetFlag(printing);
              PrnOut(CHAR(0cH)); (* send formfeed *)
              WHILE (currentpos#endpos) AND (NOT CheckResetFlag(printabort)) DO
                 PrnOut(CHAR(char^));
                 INC(currentpos);
                 INC(char);
              END;
              ok:=Free(C);
              currentprocess^.errno:=0;
           ELSE
              currentprocess^.errno:=12;
           END;
        END;
        ResetFlag(printing);
        MultiBegin;
        TermProcess(currentprocess^.pid);
END     SP;

PROCEDURE       IP;
BEGIN
        currentprocess^.ipname:=name;
        currentprocess^.iptail:=tail; 
        currentprocess^.ipenvstr:=envstr;
        INC(OpenWindows);
        MultiBegin;
        Exec(loadExecute,currentprocess^.ipname,
                  currentprocess^.iptail,
                  currentprocess^.ipenvstr,
                  currentprocess^.return);
        MultiEnd;
        IF currentprocess^.return#0 THEN
           currentprocess^.errno:=2;
        ELSE
           currentprocess^.errno:=0;
        END;
        DEC(OpenWindows);
        IF OpenWindows=0 THEN 
           WakeupProcess(inputpid); (* wakeup input *)
        END; 
        TermProcess(currentprocess^.pid);
END     IP;

PROCEDURE       BP;
VAR             result  :       INTEGER;
BEGIN
        currentprocess^.ipname:=name;
        currentprocess^.iptail:=tail; 
        currentprocess^.ipenvstr:=envstr;
        MultiBegin;
        Exec(loadExecute,currentprocess^.ipname,
                  currentprocess^.iptail,
                  currentprocess^.ipenvstr,
                  result);
        MultiEnd;
        IF currentprocess^.return#0 THEN
           currentprocess^.errno:=2;
        ELSE
           currentprocess^.errno:=0;
        END;
        IF OpenWindows=0 THEN 
           WakeupProcess(inputpid); (* wakeup input *)
        END; 
        TermProcess(currentprocess^.pid);
END     BP;

PROCEDURE       xxx;
VAR             DispId  :       CARDINAL;
BEGIN
  WriteLn;
  WriteString(TITLE);
  WriteLn;
  OpenWindows := 1;
  Initsked;

  MultiEnd;
  request.pid:=currentprocess^.pid;
  proc:=input;
  sizewsp:=2000;
  pri:=1;
  Assign(pname,"getty:console");
  StartProcess(proc,sizewsp,pri,pname);
  OpenWindows := 0;
 
  MultiEnd;
  command:="IP CLI.PRG";
  request.magic:=MAGIC;
  SetFlag(request.req);
  MultiEnd;
  Use; (* execute command *)
  REPEAT
  SwapProcess;
  UNTIL OpenWindows>0;
 
(* CRON:=hello; *)
 SuperExec(gettick);
 cronslice:=temphz200;
 crontick:=0;
 REPEAT
     MultiEnd;
     IF CheckFlag(request.req) THEN
        Use;
        ResetFlag(request.req);
     END;
     SuperExec(gettick);
     INC(crontick,temphz200-cronslice);
     cronslice:=temphz200;
     IF crontick>12000 THEN (* run every 60 seconds *)
        crontick:=0;
        CRON;
     END;
     MultiBegin;
     SwapProcess;
  UNTIL sig2 AND (OpenWindows=0); (* until all windows have been closed *)

  MultiEnd;
  EndProcesses;
END     xxx;

PROCEDURE       Use;
VAR             i        :          CARDINAL;
                pid      :          INTEGER;
                s0       :          SIGNAL;
                done,d   :          BOOLEAN;
                a7       :          POINTER TO LONGCARD;
                sname    :          String;
                S        :          Stream;
BEGIN
        IF request.magic#MAGIC THEN
           request.magic:=0;
           currentprocess^.errno:=54;   (* V0.7 *)
           ResetFlag(request.req);
           inuse:=FALSE;
           RETURN;
        END;
        request.magic:=0;
        cmdstring:=command;
        i:=0;
        WHILE ORD(cmdstring[i])#0 DO
              cmdstring[i]:=CAP(cmdstring[i]);
              INC(i);
        END;
        inuse:=TRUE;
        scinit(ADR(cmdstring),SIZE(cmdstring));
        nxparm;
        ltext(ADR(name),SIZE(name));
        IF Compare("OFF",name)=Equal THEN
           WriteLn;
           LOOP
                WriteString(" REBOOT ");
           END;
           OpenWindows:=0;
           sig2:=TRUE;
           ResetFlag(request.req);
           inuse:=FALSE; (* clear inuse flag for next command *)
           RETURN;
        END;
        IF (Compare("PS",name)=Equal) OR (Compare("PSL",name)=Equal) THEN
           IF Compare("PS",name)=Equal THEN
              sname:=CONSOLE;
              d:=TRUE;
           ELSE
              nxparm;
              IF state.return=0 THEN
                 ltext(ADR(tail),SIZE(tail));
                 sname:=tail;
              ELSE
                 sname:=SYSLOG;
              END;
              d:=FALSE;
              Create(sname,0,result);
              IF result<0 THEN
                 sname:=SYSLOG;
                 Create(sname,0,result);
              END;
              sig1:=Close(result);
           END;
           SuperExec(showmemory); (* return memsize *)
           SetDefaultIO(sname,READWRITE,result);
           WriteLn;
           WriteString(TITLE);
           WriteLn;
           WriteString(" Top User Memory            ");
           ConvertToString(topusermem,16,FALSE,temp,sig1);
           WriteString(temp);
           WriteLn;
           WriteString(" Bottom User Memory         ");
           ConvertToString(botusermem,16,FALSE,temp,sig1);
           WriteString(temp);
           WriteLn;
           WriteString(" User Memory Left           ");
           ConvertToString(usermemleft,10,FALSE,temp,sig1);
           WriteString(temp);
           WriteLn;
           WriteString(" Total CPU Time             ");
           showtime(temphz200-slicebegin);          (* V0.7 *)
           WriteString(" Total Context Switches     ");
           ConvertToString(contextswitch,10,FALSE,temp,sig1);
           WriteString(temp);
           WriteLn;

           s0:=currentprocess;
           REPEAT
              IF s0^.pid#1 THEN
                 s0:=s0^.next
              END;
           UNTIL s0^.pid=1;
           REPEAT
              WriteString(" ---------------------------------- ");
              WriteLn;
              WriteString(" Process Name     : ");
              WriteString(s0^.name);
              WriteLn;
              WriteString(" Process ID       : ");
              WriteCard(s0^.pid,2);
              WriteLn;
              WriteString(" Parent Process ID: ");
              WriteCard(s0^.ppid,2);
              WriteLn;
              WriteString(" Process Status   : ");
              IF s0^.active THEN
                 IF s0^.ready THEN
                    WriteString(" Run ");
                 ELSE
                    WriteString(" Wait ");
                 END;
              ELSE
                 IF s0^.wsp=NIL THEN
                    WriteString(" Inactive ");
                 ELSE
                    WriteString(" Sleep ");
                 END;
              END;
              WriteLn;
              WriteString(" Priority         : ");
              WriteCard(s0^.pri,2);
              WriteLn;
              WriteString(" Init Time        : ");
              i:=CARDINAL(WShr(WAnd(s0^.time,63488),11)); (* hours *)
              WriteCard(i,2);
              WriteString(":");
              i:=CARDINAL(WShr(WAnd(s0^.time,2016),5)); (* minutes *)
              WriteCard(i,2);
              WriteString(":");
              i:=2*CARDINAL(WAnd(s0^.time,31)); (* seconds *)
              WriteCard(i,2);
              WriteString(" ");
              i:=CARDINAL(WShr(WAnd(s0^.date,480),5)); (* month *)
              WriteCard(i,2);
              WriteString("/");
              i:=CARDINAL(WAnd(s0^.date,31)); (* day *)
              WriteCard(i,2);
              WriteString("/");
              i:=80+CARDINAL(WShr(WAnd(s0^.date,65024),9)); (* year *)
              WriteCard(i,2);
              WriteLn;
              WriteString(" CPU Time         : ");
              showtime(s0^.tick);            (* V0.7 *)

     (* programs running will have their own stack to save the context *)
              WriteString(" Stack Begin      : ");
              ConvertToString(LONGCARD(s0^.wsp)+s0^.wspsize,16,FALSE,temp,done);
              IF s0^.wsp#NIL THEN
                 WriteString(temp);
              ELSE
                 WriteString("NONE ");
              END;
              WriteLn;

              WriteString(" Stack Adr        : ");
              showaddress(LONGCARD(s0^.cor),s0); (* V0.7 make subroutine *)
              WriteString(" Super Stack Adr  : ");
              showaddress(LONGCARD(s0^.ssp),s0);
              WriteString(" Bios Pointer     : ");
              showaddress(LONGCARD(s0^.biosval),s0);
              WriteString(" Coroutine PC     : ");
              showaddress(LONGCARD(s0^.pc),s0);
              WriteString(" Coroutine SR     : ");
              showaddress(LONGCARD(s0^.sr),s0);

              s0:=s0^.next;
              IF d THEN
                 IF s0^.pid#0 THEN
                    WriteString(" Press RETURN for next.");
                    WriteLn;
                    ReadString(temp);
                 ELSE
                    WriteString(" Press RETURN to EXIT.");
                    WriteLn;
                    ReadString(temp);
                 END;
              END;
           UNTIL s0^.pid=0;
           sname:=CONSOLE;
           SetDefaultIO(sname,READWRITE,result);
           ResetFlag(request.req);
           inuse:=FALSE;
           RETURN;
        END;
        IF Compare("IP",name)=Equal THEN
           nxparm;                  (* V0.7 *)
           ltext(ADR(temp),SIZE(temp));
           ConvertToInteger(temp,done,pri);
           IF NOT done THEN 
              pri:=10;
              bkparm;
           END;
           nxparm;
           ltext(ADR(name),SIZE(name));
           nxparm;
           etext(ADR(tail[1]),SIZE(tail));
           bkparm;
           etext(ADR(envstr),SIZE(envstr));
           tail[0]:=CHAR(Length(envstr));
           envstr:='';
           FOR i:=0 TO 79 DO
               pname[i]:=name[i];
           END;
           ResetFlag(request.req);
           inuse:=FALSE;
           proc:=IP;
           sizewsp:=2000;
           StartProcess(proc,sizewsp,pri,pname);
           RETURN;
        END;
        IF Compare("BP",name)=Equal THEN
           nxparm;                  (* V0.7 *)
           ltext(ADR(temp),SIZE(temp));
           ConvertToInteger(temp,done,pri);
           IF NOT done THEN 
              pri:=2;
              bkparm;
           END;
           nxparm;
           ltext(ADR(name),SIZE(name));
           nxparm;
           etext(ADR(tail[1]),SIZE(tail));
           bkparm;
           etext(ADR(envstr),SIZE(envstr));
           tail[0]:=CHAR(Length(envstr));
           envstr:='';
           FOR i:=0 TO 79 DO
               pname[i]:=name[i];
           END;
           ResetFlag(request.req);
           inuse:=FALSE;
           proc:=BP;
           sizewsp:=2000;
           StartProcess(proc,sizewsp,pri,pname);
           RETURN;
        END;
        IF Compare("SP",name)=Equal THEN
           nxparm;
           ltext(ADR(name),SIZE(name));
           pname[0]:='S'; pname[1]:='P'; pname[2]:=' ';
           tail[0]:=0C;
           envstr[2]:=0C;
           done:=Pos(name,':',0,i);
           IF NOT done THEN
              GetPath(tail,0);
              GetDrv(i);
              envstr[0]:=CHAR(41H+i);
              envstr[1]:=':';
              Concat(envstr,tail,envstr);
              Concat(envstr,'\',envstr);
              Concat(envstr,name,envstr);
              name:=envstr;
           END;
           FOR i:=3 TO 78 DO
               pname[i]:=name[i-3];
           END;
           pname[79]:=CHAR(0);
           ResetFlag(request.req);
           inuse:=FALSE;
           proc:=SP;
           sizewsp:=2000;
           pri:=3;
           StartProcess(proc,sizewsp,pri,pname);
           RETURN;
        END;
        IF Compare("ASP",name)=Equal THEN
           SetFlag(printabort);
           ResetFlag(request.req);
           inuse:=FALSE;
           RETURN;
        END;
        IF Compare("PID",name)=Equal THEN
           WriteString(" Process ID number = ");
           WriteCard(CARDINAL(request.pid),4);
           WriteLn;
           ResetFlag(request.req);
           inuse:=FALSE;
           RETURN;
        END;
        IF Compare("NICE",name)=Equal THEN
           nxparm;
           ltext(ADR(name),SIZE(name));
           ConvertToInteger(name,done,pri);
           IF NOT done THEN
              ResetFlag(request.req);
              inuse:=FALSE;
              RETURN;
           END;
           nxparm;
           ltext(ADR(name),SIZE(name));
           IF state.return=0 THEN
              ConvertToInteger(name,done,pid);
              IF NOT done THEN
                 pid:=request.pid;
              END;
           ELSE
              pid:=request.pid;
           END;
           ChangeProcessPriority(pid,pri);
           ResetFlag(request.req);
           inuse:=FALSE;
           RETURN;
        END;
        IF Compare("HP",name)=Equal THEN
           nxparm;
           ltext(ADR(name),SIZE(name));
           ConvertToInteger(name,done,pid);
           IF done THEN
              SleepProcess(pid);
           ELSE
              currentprocess^.errno:=3;
           END;
           ResetFlag(request.req);
           inuse:=FALSE;
           RETURN;
        END;
        IF Compare("WP",name)=Equal THEN
           nxparm;
           ltext(ADR(name),SIZE(name));
           ConvertToInteger(name,done,pid);
           IF done THEN
              WakeupProcess(pid);
           ELSE
              currentprocess^.errno:=3;
           END;
           ResetFlag(request.req);
           inuse:=FALSE;
           RETURN;
        END;
     ResetFlag(request.req);
     inuse:=FALSE;
END     Use;

(*$P- *)
PROCEDURE       showmemory;
VAR             memsize :       ADDRESS;
BEGIN
        topusermem:=memtop;
        botusermem:=membot;
        temphz200:=hz200;
        Alloc(LONGCARD(-1),memsize);
        usermemleft:=LONGCARD(memsize);
        CODE(4e75H); (* rts *)
END     showmemory;
(*$P+ *)

(*$P- *)
PROCEDURE       gettick;
BEGIN
        temphz200:=hz200;
        CODE(4e75H); (* rts *)
END     gettick;
(*$P+ *)

PROCEDURE       showtime(tick: LONGCARD);       (* V0.7 make subroutine *)
VAR             sec            :        REAL;
                min,hour       :        LONGCARD;
                done           :        BOOLEAN;
BEGIN
           sec:=FLOAT(tick);
           sec:=sec/200.0;
           min:=TRUNCD(sec) DIV 60;
           hour:=min DIV 60;
           min:=min-(hour*60);
           ConvertToString(hour,10,FALSE,temp,sig1);
           scinit(ADR(temp),SIZE(temp));
           nxparm;
           ltext(ADR(temp),SIZE(temp));
           WriteString(temp);
           WriteString(":");
           ConvertToString(min,10,FALSE,temp,sig1);
           scinit(ADR(temp),SIZE(temp));
           nxparm;
           ltext(ADR(temp),SIZE(temp));
           WriteString(temp);
           WriteString(":");
           sec:=sec-FLOAT(min*60)-FLOAT(hour*3600);
           ConvertReal(sec,11,3,temp);
           scinit(ADR(temp),SIZE(temp));
           nxparm;
           ltext(ADR(temp),SIZE(temp));
           WriteString(temp);
           WriteString("  HOUR:MIN:SEC");
           WriteLn;
END             showtime;

(* V0.7 make subroutine *)
PROCEDURE       showaddress(adr: LONGCARD; s0: SIGNAL); 
VAR             done             :          BOOLEAN;
BEGIN
              ConvertToString(adr,16,FALSE,temp,done);
              WriteString(temp);
              IF s0^.wsp=NIL THEN
                 WriteString(" Last Value ");
              END;
              WriteLn;
END             showaddress;

PROCEDURE       hello;
BEGIN
        WriteString(" HELLO ");
END     hello;

(* ------------------------------------------------------------------- *)

BEGIN
        BConOut(CON,33C);
        BConOut(CON,'E');
        inuse:=FALSE;
        sig1:=TRUE;
        sig2:=FALSE; 
        InitProcesses;
        request.pid:=currentprocess^.pid;
        MultiEnd;
        proc:=xxx;
        sizewsp:=2000;
        pri:=1;
        Assign(pname,"init");
        StartProcess(proc,sizewsp,pri,pname);
END AMULTI.
