(* V0.8     5/28/87 Copyright 1987 fred brooks LogicTek *)
(*$Q+ *)
                (* Set priority as to not allow interrupts *)
IMPLEMENTATION MODULE          ATOMIC[7]; 
(* IMPORT         GEMError; *)
FROM  SYSTEM  IMPORT   NEWPROCESS,PROCESS,TRANSFER,IOTRANSFER,ADR,TSIZE,
                       CODE,SETREG,ADDRESS,REGISTER,BYTE;
FROM  XBIOS   IMPORT   SuperExec,IORECPTR,IOREC,IORec,SerialDevice;

FROM  GEMDOS  IMPORT   GetTime,GetDate,Alloc,Free;

FROM  Strings IMPORT   String;

TYPE    workspace       =       ARRAY [0..255] OF CARDINAL;
        savetype        =       POINTER TO ARRAY [0..22] OF CARDINAL;

VAR        s0,s1,s2,schedproc   :       SIGNAL;
           wsp0,wsp1,wsp2,wsp3  :       workspace;
           wsp,schedvector,bios :       ADDRESS;
           trap15 [0bcH]        :       ADDRESS;
           txbuferr [128H]      :       ADDRESS;
           biospointer [4a2H]   :       ADDRESS;
           termvec     [408H]   :       ADDRESS;
           trap [134H]          :       ADDRESS;
           membot [432H]        :       ADDRESS;
           memtop [436H]        :       ADDRESS;
           flock [43eH]         :       CARDINAL;
           hz200  [4baH]        :       LONGCARD;
           temphz200,delay      :       LONGCARD;
           sysvector [144H]     :       POINTER TO sysvariable;
           sysvar               :       sysvariable;
           oldtrap,oldtermvec   :       ADDRESS;
           p,cotick,x,t,temp    :       PROCESS;
           processesid,I        :       INTEGER;
           duration,RSbufsize   :       CARDINAL;
           done,zombie,noint    :       BOOLEAN;
           savefrom,saveto      :       savetype;
           RSt                  :       IORECPTR;
           TSR [0fffffa2cH]     :       BITSET; (* rs232 xmit status *)

        (* --------------  BEGIN -------------- *)

PROCEDURE       StartProcess(VAR P        : PROC;
                             VAR n        : LONGCARD;
                             VAR priority : INTEGER;
                             VAR pn       : String);
BEGIN
        SuperExec(getbiosptr);
        SuperExec(IncSlice);
        Alloc(n,wsp);
        IF wsp=NIL THEN
           currentprocess^.errno:=12;
           RETURN;
        END;
        s1:=currentprocess;
        s0:=currentprocess;
        zombie:=FALSE;

        IF processesid>0 THEN    (* search only after setup of SCHED *)
        s0:=schedproc;               (* set to sched process *)
         LOOP                    (* find zombie process *)
          s0:=s0^.next;
          IF s0^.pid=1 THEN      (* zombie not found in list *)
             EXIT;
          END;
          IF (NOT s0^.active) AND (s0^.pid#0) AND (s0^.wsp=NIL) THEN 
             zombie:=TRUE; (* found one *)
             EXIT;
          END;
         END;
        END; (* if processesid>1 *)

        IF zombie THEN
           currentprocess:=s0;
        ELSE
           Alloc(TSIZE(ProcessDescriptor),currentprocess);
           IF currentprocess=NIL THEN
              s1^.errno:=12;
              RETURN;
           END;
           INC(processesid);
           currentprocess^.pid:=processesid;
           currentprocess^.next:=s1^.next; s1^.next:=currentprocess;
        END;

        WITH currentprocess^ DO
             name:=pn;
             ppid:=request.pid;
             ready:=TRUE; active:=TRUE; queue:=NIL;
             tick:=0;
             IF priority<1 THEN priority:=1 END;
             IF priority>10 THEN priority:=10 END;
             pri:=priority;
             GetTime(time);
             GetDate(date);
        END;
        IF currentprocess^.pid>1 THEN
           s2:=FindProcess(request.pid);
           s2^.return:=currentprocess^.pid;
        ELSE
           currentprocess^.return:=0;
        END;
        SuperExec(SetSlice);
        currentprocess^.slice:=temphz200;
        currentprocess^.wsp:=wsp;
        currentprocess^.wspsize:=n;
        NEWPROCESS(P,wsp,CARDINAL(n),currentprocess^.cor);
        SuperExec(intbiosptr);
        s1^.errno:=0;
        INC(contextswitch);            (* update switch counter *)
        TRANSFER(s1^.cor,currentprocess^.cor);
END     StartProcess;

PROCEDURE       TermProcess(VAR id: INTEGER);
BEGIN
        IF id<2 THEN RETURN END;

        s2:=FindProcess(id);
        IF s2=NIL THEN
           currentprocess^.errno:=3;
           RETURN;
        END;
        currentprocess^.errno:=0;

        s2^.active:=FALSE;      (* set flag *)
        done:=Free(s2^.wsp);
        s2^.wsp:=NIL;           (* set TO NIL to make zombie process *)

        currentprocess^.errno:=0;
        s1:=currentprocess;     (* save currentprocess *)
        currentprocess:=s2;     (* set currentprocess to terminated *)
        SuperExec(getbiosptr);
        SuperExec(IncSlice);    (* update cpu time for terminated *)

        currentprocess:=schedproc;  (* set to transfer to the sched *)

        IF s1^.pid#id THEN
           temp:=s1^.cor; (* currentprocess different than terminated *)
        ELSE
           temp:=t;     (* process the same so set up dummy process *)
        END;

        IF s1^.pid#1 THEN
           SuperExec(SetSlice);
           currentprocess^.slice:=temphz200;
           SuperExec(ClrInt);
           duration:=25*currentprocess^.pri;
           SuperExec(SetTimer);
           SuperExec(EnableInterrupt13);
           SuperExec(setbiosptr);
           INC(contextswitch);            (* update switch counter *)
           TRANSFER(temp,currentprocess^.cor); (* do context switch *)
        END;
END             TermProcess;

PROCEDURE       SleepProcess(VAR id: INTEGER);
BEGIN
        IF id<2 THEN RETURN END;

        s2:=FindProcess(id);
        IF s2=NIL THEN
           currentprocess^.errno:=3;
           RETURN;
        END;
        currentprocess^.errno:=0;

        IF (s2^.wsp#NIL) AND (NOT s2^.active) THEN RETURN END;
        IF s2^.wsp#NIL THEN 
           s2^.active:=FALSE;      (* set flag *)
        END;

        s1:=currentprocess;     (* save currentprocess *)
        SuperExec(getbiosptr);
        SuperExec(IncSlice);    (* update cpu time for sleeper *)

        currentprocess:=schedproc;  (* set to transfer to the sched *)

        IF s1^.pid#1 THEN
           s1^.ready:=FALSE; currentprocess^.ready:=TRUE;
           SuperExec(SetSlice);
           currentprocess^.slice:=temphz200;
           SuperExec(ClrInt);
           duration:=25*currentprocess^.pri;
           SuperExec(SetTimer);
           SuperExec(EnableInterrupt13);
           SuperExec(setbiosptr);
           INC(contextswitch);            (* update switch counter *)
           TRANSFER(s1^.cor,currentprocess^.cor); (* do context switch *)
        END;
END             SleepProcess;

PROCEDURE       WakeupProcess(VAR id: INTEGER);
BEGIN
        IF id<2 THEN RETURN END;

        s2:=FindProcess(id);
        IF s2=NIL THEN
           currentprocess^.errno:=3;
           RETURN;
        END;

        IF (s2^.wsp#NIL) AND s2^.active THEN 
           currentprocess^.errno:=0;
           RETURN; (* already awake *)
        END;

        IF s2^.wsp#NIL THEN 
           s2^.active:=TRUE;      (* set flag *)
           currentprocess^.errno:=0;
        ELSE
           currentprocess^.errno:=3;
        END;
END             WakeupProcess;

(* V0.7 *)
PROCEDURE       ChangeProcessPriority(VAR id: INTEGER; VAR pri: INTEGER);
BEGIN
        IF id<2 THEN RETURN END;

        s2:=FindProcess(id);
        IF s2=NIL THEN
           currentprocess^.errno:=3;
           RETURN;
        END;

        IF pri<1  THEN pri:=1 END;
        IF pri>10 THEN pri:=10 END;
        s2^.pri:=pri;

END             ChangeProcessPriority;

PROCEDURE       InitProcesses;
BEGIN
        CRON:=dummy;
        RSt:=IORECPTR(LONGCARD(IORec(RS232))+LONGCARD(TSIZE(IOREC)));
        RSbufsize:=RSt^.ibufsize;
        RSt^.ibufsize:=1;
        Alloc(TSIZE(ProcessDescriptor),currentprocess);
        processesid:=0;
        WITH currentprocess^ DO
             next:=currentprocess;
             ready:=FALSE;
             active:=FALSE;
             queue:=NIL;
             name:="INIT";
             GetTime(time);
             GetDate(date);
        END;
        NEWPROCESS(dummy,ADR(wsp1),TSIZE(workspace),x);
        NEWPROCESS(dummy,ADR(wsp2),TSIZE(workspace),p);
        NEWPROCESS(dummy,ADR(wsp3),TSIZE(workspace),t);
        currentprocess^.wsp:=ADR(wsp2);
        currentprocess^.cor:=p;
END             InitProcesses;

PROCEDURE       EndProcesses;
BEGIN
        RSt^.ibufsize:=RSbufsize;
        s0:=currentprocess;
        REPEAT
                currentprocess:=s0^.next;
                s0:=currentprocess;
        UNTIL currentprocess^.pid=0;
        SuperExec(restorebiosptr);
        INC(contextswitch);            (* update switch counter *)
        TRANSFER(currentprocess^.cor,currentprocess^.cor);
END     EndProcesses;

(* This is the scheduler which is called by newtrap *)
PROCEDURE       sched;  
BEGIN
        IOTRANSFER(cotick,x,ADDRESS(134H));
        LOOP
             currentprocess^.cor:=x;
             currentprocess^.ready:=FALSE;
             currentprocess^.intflag:=TRUE; (* process interrupted *)
             INC(contextswitch);            (* update switch counter *)
             currentprocess:=s0; (* s0 set to new in newtrap procedure *)
             currentprocess^.ready:=TRUE;   (* process to start *)
             x:=currentprocess^.cor;
             IOTRANSFER(cotick,x,ADDRESS(140H)); (* offset vector so not *)
        END;                                     (* to overwrite the     *)
END     sched;                                   (* newtrap vector       *)

PROCEDURE       SwapProcess; (* swap out processes *)
BEGIN
        SuperExec(getbiosptr);
        SuperExec(IncSlice);
        s0:=currentprocess;
        currentprocess^.ready:=FALSE;
        LOOP (* find next process *)
          currentprocess:=currentprocess^.next;
          IF currentprocess^.active AND (currentprocess^.wsp#NIL) THEN 
             EXIT 
          END;
        END; (* loop *)
        currentprocess^.ready:=TRUE;
        IF s0^.pid#currentprocess^.pid THEN
           SuperExec(SetSlice);
           currentprocess^.slice:=temphz200;
           SuperExec(ClrInt);
           duration:=25*currentprocess^.pri;
           SuperExec(SetTimer);
           SuperExec(EnableInterrupt13);
           SuperExec(setbiosptr);
           INC(contextswitch);            (* update switch counter *)
           TRANSFER(s0^.cor,currentprocess^.cor);
        END; 
END     SwapProcess;

PROCEDURE       dummy; (* dummy procedure to make newprocess *)
BEGIN
END             dummy;

PROCEDURE       FindProcess(pid: INTEGER): SIGNAL;
VAR             s                :         SIGNAL;
BEGIN
        s:=schedproc;
        LOOP                    (* find  process id *)
          s:=s^.next;
          IF s^.pid=pid THEN     (* found id *)
             RETURN s;
          END;
          IF s^.pid=schedproc^.pid THEN      (* id not found in list *)
             RETURN NIL;
          END;
        END;
END     FindProcess;

(*$P-,S- *)
PROCEDURE   IncSlice; (* UPDATE cpu time  *)
BEGIN
        INC(currentprocess^.tick,hz200-currentprocess^.slice);
        currentprocess^.slice:=hz200;
        CODE(4e75H); (* rts *)
END         IncSlice;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE   SetSlice; (* start timeslice  *)
BEGIN
        temphz200:=hz200;
        CODE(4e75H); (* rts *)
END         SetSlice;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE       stopint;
BEGIN
        CODE(41f9H,0ffffH,0fa07H); (* lea mfp enable a to d0 *)
        CODE(3e3cH,5H,0f90H);      (* load 5 to d7 then bclr *)
        CODE(4e75H);               (* rts *)
END             stopint;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE   SetTimer; (* setup timerA  *)
BEGIN
        SETREG(0,0);
        SETREG(1,7);            (* div by 200 *)
        SETREG(2,duration);     (* set count down *)
        CODE(4eb9H,0fcH,2366H); (* set timer *)
        CODE(4e75H); (* rts *)
END         SetTimer;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE   ClrInt;
BEGIN
        SETREG(8,0fffffa0bH);   (* load a0 with adr of mfp reg *)
        CODE(0,0,890H,5H);  (* clear timer a int pend bit *)
        SETREG(8,0fffffa0fH);   (* load a0 with adr of mfp reg *)
        CODE(0,0,890H,5H);  (* clear timer a int svc bit *)
        CODE(4e75H); (* rts *)
END         ClrInt;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE   EnableInterrupt13;
BEGIN                           (* setup sched vector interrupt *)
        SETREG(8,0fffffa07H);   (* load a0 with adr of mfp reg *)
        CODE(0,0,8d0H,5H);  (* set timer a int enable bit *)
        SETREG(8,0fffffa13H);   (* load a0 with adr of mfp reg *)
        CODE(0,0,8d0H,5H);  (* set timer a int mask bit *)

        SETREG(8,0fffffa0bH);   (* load a0 with adr of mfp reg *)
        CODE(0,0,8d0H,2H);  (* set  int pend bit *) 
        SETREG(8,0fffffa0fH);   (* load a0 with adr of mfp reg *)
        CODE(0,0,890H,2H);  (* clear  int svc bit *) 
        CODE(4e75H); (* rts *)
END         EnableInterrupt13;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE   EnableRS232Interrupt;
BEGIN
        SETREG(8,0fffffa0bH);   (* load a0 with adr of mfp reg *)
        CODE(0,0,8d0H,2H);  (* set  int pend bit *) 
        SETREG(8,0fffffa0fH);   (* load a0 with adr of mfp reg *)
        CODE(0,0,890H,2H);  (* clear  int svc bit *) 
        CODE(4e75H); (* rts *)
END         EnableRS232Interrupt;
(*$P+,S+ *)

PROCEDURE       MultiBegin;
BEGIN
        MULTI:=TRUE;
        SuperExec(ClrInt);
        duration:=25;
        SuperExec(SetTimer);
        SuperExec(EnableInterrupt13);
END             MultiBegin;

PROCEDURE       MultiEnd;
BEGIN
        MULTI:=FALSE;
        SuperExec(stopint);
        SuperExec(EnableRS232Interrupt);
END             MultiEnd;

(*$P-,S- *)
PROCEDURE       getbiosptr;
BEGIN
        currentprocess^.biosval:=biospointer+46;
        currentprocess^.termvec:=termvec;
        CODE(4e75H);               (* rts *)
END             getbiosptr;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE       setbiosptr;
BEGIN
        savefrom:=ADDRESS(biospointer);
        saveto:=ADDRESS(currentprocess^.biosval-46);
        saveto^:=savefrom^;
        biospointer:=currentprocess^.biosval-46;
        termvec:=currentprocess^.termvec;
        CODE(4e75H);               (* rts *)
END             setbiosptr;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE       restorebiosptr;
BEGIN
        savefrom:=biospointer;
        saveto:=bios;
        saveto^:=savefrom^;
        biospointer:=bios;
        termvec:=oldtermvec;
        CODE(4e75H);               (* rts *)
END             restorebiosptr;
(*$P+,S+ *)

(*$P-,S- *)
PROCEDURE       intbiosptr;
BEGIN
        savefrom:=ADDRESS(biospointer);
        saveto:=ADR(currentprocess^.biosave[175]);
        saveto^:=savefrom^;
        currentprocess^.biosval:=ADR(currentprocess^.biosave[175]);
        biospointer:=currentprocess^.biosval;
        currentprocess^.termvec:=termvec;
        CODE(4e75H);               (* rts *)
END             intbiosptr;
(*$P+,S+ *)

(*$P- *) 
PROCEDURE       newtrap; (* IOTRANSFER executes this code before its *)
BEGIN                    (* normal vector. *)
        CODE(46fcH,2700H);      (* set no ints *)
        CODE(48e7H,0fffeH);   (* save regs movem  *)
        CODE(206fH,3eH); (* move.l 62(a7),a0 get pc *)
        currentprocess^.pc:=REGISTER(8);
        CODE(306fH,3cH); (* move.w 60(a7),a0 get sr *)
        currentprocess^.sr:=CARDINAL(REGISTER(8));
        CODE(204fH);    (* move.l ssp,a0 *)
        currentprocess^.ssp:=REGISTER(8)+66;

        IF (currentprocess^.sr>3FFH) 
           OR (currentprocess^.pc>memtop)
           OR (flock#0) 
           OR (currentprocess^.ssp#4db8H)
        THEN
           ClrInt;
           duration:=25*currentprocess^.pri;
           SetTimer;
           EnableInterrupt13;
           CODE(4cdfH,7fffH); (* restore regs movem *)
           CODE(4e73H);       (* rte *)
        ELSE

           IncSlice;   (* cpu time update *)
           s0:=currentprocess;
           LOOP                    (* find next process store in s0 *)
                s0:=s0^.next;
                IF (s0^.active) AND (s0^.wsp#NIL) THEN EXIT END;
           END; (* end LOOP *)
           ClrInt;
           duration:=25*s0^.pri;
           SetTimer;
           EnableInterrupt13;
           s0^.slice:=hz200; (* set next cycle start *)
           currentprocess^.biosval:=biospointer;
           currentprocess^.termvec:=termvec;
           biospointer:=s0^.biosval;
           termvec:=s0^.termvec;
           SETREG(8,oldtrap);  (* move IOTRANSFER trap adr *)
           CODE(43faH,10); (* lea 12(pc),a1 *)
           CODE(2288H); (* move.l a0,(a1) *)
           CODE(4cdfH,7fffH); (* restore regs movem *)
           CODE(4ef9H,0,0) (* jmp back to routine *)
        END;
END     newtrap;
(*$P+ *)

(*$P- *) (*save trap and set up flag trap for IOTRANSFER to run my code *)
PROCEDURE       settrap;     (* before executing the IOTRANSFER.        *)
BEGIN
        oldtrap:=trap;
        trap:=ADDRESS(newtrap);
        sysvector:=ADR(sysvar);         (* setup sysvar pointers *)
        sysvar.currentprocess:=ADR(currentprocess);
        sysvar.MULTI:=ADR(MULTI);
        sysvar.slicebegin:=ADR(slicebegin);
        sysvar.command:=ADR(command);
        sysvar.request:=ADR(request);
        sysvar.contextswitch:=ADR(contextswitch); (* V0.7 *)
        sysvar.CRON:=ADR(CRON);
        slicebegin:=hz200;
        contextswitch:=0;
        bios:=biospointer;      (* save original pointer *)
        oldtermvec:=termvec;
        trap15:=txbuferr;       (* set trap15 to xmit buffer vector *)
        CODE(4e75H); (* rts *)
END     settrap;
(*$P+ *)

PROCEDURE       Initsked;
BEGIN
        MultiEnd;
        duration:=250;
        SuperExec(SetTimer);
        NEWPROCESS(sched,ADR(wsp0),TSIZE(workspace),cotick);
        TRANSFER(x,cotick);
        schedproc:=currentprocess;
        SuperExec(settrap);
END             Initsked;

PROCEDURE       CheckFlag(VAR flag: BOOLEAN): BOOLEAN;
BEGIN
        IF flag THEN
           RETURN TRUE;
        ELSE
           RETURN FALSE;
        END;
END     CheckFlag;

PROCEDURE       SetFlag(VAR flag: BOOLEAN);
BEGIN
        flag:=TRUE;
END     SetFlag;

PROCEDURE       ResetFlag(VAR flag: BOOLEAN);
BEGIN
        flag:=FALSE;
END     ResetFlag;

PROCEDURE       CheckResetFlag(VAR flag: BOOLEAN): BOOLEAN;
BEGIN
        IF flag THEN
           flag:=FALSE;
           RETURN TRUE;
        ELSE
           RETURN FALSE;
        END;
END     CheckResetFlag;

BEGIN
END     ATOMIC.
